import java.io.*; 
import java.net.*; 
  
class TCPChat_server { 
	public static void main(String args[]) throws Exception {

		if (args.length!=1) {
			System.out.println("use: TCPChat-server <port>");
			System.exit(0);
		}
		int port = Integer.parseInt(args[0]);

		// prepare to read from the input
		BufferedReader inFromServer = new BufferedReader(new InputStreamReader(System.in)); 

		ServerSocket welcomeSocket = new ServerSocket(port); 
		System.out.println ("The server is listening on port " + port);
		System.out.println("Waiting for connections...");

		Socket connectionSocket = welcomeSocket.accept(); // a connection arrived

		System.out.println("Connection arrived on port " + connectionSocket.getLocalPort());
		System.out.println("from IP address " + connectionSocket.getInetAddress());

		BufferedReader inFromClient = new BufferedReader(new InputStreamReader(connectionSocket.getInputStream())); 
		DataOutputStream  outToClient = new DataOutputStream(connectionSocket.getOutputStream()); 

		while(true) { 
			// read the incoming information and display it
			String clientSentence = inFromClient.readLine(); 
			System.out.println("user > " + clientSentence);

			// reply to message
			System.out.print("you > ");
			String reply = inFromServer.readLine();
			//String reply = "hi!\n";
			outToClient.writeBytes(reply+'\n'); //send out the result
		}
	} 
}  
