import java.io.*; 
import java.net.*; 
  
class TCPChat_client { 
	public static void main(String args[]) throws Exception {

		if (args.length<2) {
			System.out.println("use: TCPChat_client <IP-address> <port>");
			System.exit(0);
		}
		int port = Integer.parseInt(args[1]);

		BufferedReader inFromUser = new BufferedReader(new InputStreamReader(System.in));

		Socket clientSocket = new Socket(args[0], port);
		System.out.println("Client on port " + clientSocket.getLocalPort());
		System.out.println("Client connected to port " + clientSocket.getPort());

		DataOutputStream outToServer = new DataOutputStream(clientSocket.getOutputStream()); 
		BufferedReader inFromServer = new BufferedReader(new InputStreamReader(clientSocket.getInputStream())); 

		while(true) { 

			// send what the user writes
			System.out.print("you > ");
			String sentence = inFromUser.readLine(); 
			outToServer.writeBytes(sentence + '\n');

			// read and display the reply
			String modifiedSentence = inFromServer.readLine();
			System.out.println("server > " + modifiedSentence);
		}
	} 
}
